BUS_GET_CPUS(9)

NAME
BUS_GET_CPUS, bus_get_cpus - request a set of device-specific CPUs

SYNOPSIS
#include <sys/param.h>
#include <sys/bus.h>
#include <sys/cpuset.h>
int
BUS_GET_CPUS(device_t dev, device_t child, enum cpu_sets op, size_t setsize, cpuset_t *cpuset);
int
bus_get_cpus(device_t dev, enum cpu_sets op, size_t setsize, cpuset_t *cpuset);

DESCRIPTION
The BUS_GET_CPUS() method queries the parent bus device for a set of device-specific CPUs. The op argument specifies which set of CPUs to retrieve. If successful, the requested set of CPUs are returned in cpuset. The setsize argument specifies the size in bytes of the set passed in cpuset.

BUS_GET_CPUS() supports querying different types of CPU sets via the op argument. Not all set types are supported for every device. If a set type is not supported, BUS_GET_CPUS() fails with EINVAL. These set types are supported:

LOCAL_CPUS
    The set of CPUs that are local to the device. If a device is closer to a specific memory domain in a non-uniform memory architecture system (NUMA), this will return the set of CPUs in that memory domain.

INTR_CPUS
    The preferred set of CPUs that this device should use for device interrupts. This set type must be supported by all bus drivers.

The bus_get_cpus() function is a simple wrapper around BUS_GET_CPUS().

RETURN VALUES
Zero is returned on success, otherwise an appropriate error is returned.

SEE ALSO
cpuset(2), BUS_BIND_INTR(9), device(9)

HISTORY
The BUS_GET_CPUS() method and bus_get_cpus() function first appeared in FreeBSD 11.0.